image: maven:3.6.3-jdk-8
stages:
  - Build
  - Test
  - Deploy
  - Prod

#before_script:
  # Install JFrog CLI
 # -  curl -fL https://getcli.jfrog.io | sh
  # Configure Artifactory instance with JFrog CLI
  #- ./jfrog rt config --url=$ARTIFACTORY_URL --user=$ARTIFACTORY_USER --password=$ARTIFACTORY_PASS
  #- ./jfrog rt c show
  # Set the M2_HOME environment variable
 # - export M2_HOME=/usr/share/maven
  # Replace the repository name in the configuration.yml to the correct one.
 # - sed -i 's,MAVEN_REPO_KEY,'"$MAVEN_REPO_KEY"',g' configuration.yml

build:
  stage: Build
  script:
    - mvn clean compile -U
  only:
    refs:
      - master
    
    # Run the MVN command
    # - ./jfrog rt mvn "clean install" configuration.yml --build-name=gitlabci-maven-artifactory --build-number=$CI_JOB_ID
    # Collect the environment variables
    # - ./jfrog rt bce gitlabci-maven-artifactory $CI_JOB_ID
    # Pass the build information to Artifactory
    # - ./jfrog rt bp gitlabci-maven-artifactory $CI_JOB_ID

  
test:
  stage: Test
  when: always
  script:
    - mvn clean test
  only:
    refs:
      - master
  artifacts:
    when: always
    reports:
      junit:
        - target/surefire-reports/TEST-*.xml    

deploy:
  stage: Deploy
  script:
    - mvn clean install
  only:
    refs:
      - master
  artifacts:
    paths:
       - target/demo-0.0.1-SNAPSHOT.jar
    name: demo-0.0.1-SNAPSHOT

prod:
  only:
    refs:
      - master
  stage: Prod
  when: manual
  allow_failure: false
  script:
    - echo 'prod deploy completed'
